#include <stdlib.h>
#include <stdio.h>
#ifdef __APPLE__
#include <GLUT/glut.h>
#else
#include <GL/glut.h>
#endif
#include <math.h>

#include "tb.h"

int width, height;
int xmin, ymin;

#define NUMPART 1000
#define DIMENSION 2

float position[NUMPART][2*DIMENSION];
float force[NUMPART][2*DIMENSION];
float un_sur_m[NUMPART];/* Inverse de la masse de chaque particule. */ 
float age[NUMPART];/* Age de chaque particule. Negatif : particule pas encore active. Superieur a age limite : particule desactivee. */ 

float source[DIMENSION]; /* source emittrice de particules */
float debit = 3; /* 3 particules par seconde */
float step = 0.1; /* 10 pas par seconde */


void idle()
{
  int i;

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
  glColor3f(0.2, 0.2, 0.8);
  createParticules();
  computeForces();
  animateParticules();
  ageParticules();

  glPushMatrix();
  if (DIMENSION == 3) {
    tbMatrix();
  }
  glPointSize(2.0);
  glBegin(GL_POINTS);
  for (i = 0; i < NUMPART; i++) {
    if (particuleActive(i)) {
      if (DIMENSION == 2) 
	glVertex2f(position[i][0], position[i][1]);
      else 
	glVertex3f(position[i][0], position[i][1], position[i][2]);
    }
  }
  glEnd();
  glutSwapBuffers();
  glPopMatrix();
}



void
mouse(int button, int state, int x, int y)
{
  if (dimension == 3) 
    tbMouse(button, state, x, y);
}


void
motion(int x, int y)
{
  if (dimension == 3)
    tbMotion(x, y);
}

void printHelp()
{
  printf("Systems de particules integration\n\n");
}


void myReshape(int w, int h)
{
  if (DIMENSION == 3)
    tbReshape(w, h);
  xmin = 0;
  ymin = 0;
  if (w > h) {
    xmin = (w-h)/2;
    w = h;
  } else {
    ymin = (h-w)/2;
    h = w;
  }
  width = w;
  height = h;
  glViewport(xmin, ymin, w, h);
}

void myinit(void)
{
  glLoadIdentity();
  glColor3f(1.0, 0.0, 0.0);
  glClearColor(0.0, 0.0, 0.1, 1.0);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);

  if (DIMENSION == 3) {
    tbInit(GLUT_LEFT_BUTTON);
    tbAnimate(GL_TRUE);
  }
  glLoadIdentity();
  /* Penser a initialiser les positions des particules et les ressorts */
}


int main(int argc, char *argv[]) 
{
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE | GLUT_MULTISAMPLE );
  glutCreateWindow("Systemes de particules");
  glutInitWindowSize(1200, 1200);
  glutInitWindowPosition(200, 0);
  glutIdleFunc(idle);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutReshapeFunc(myReshape);
  myinit();
  printHelp();
    
  glutMainLoop();
  return 0;
}
